﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Data.SqlClient;
using ICSharpCode.SharpZipLib.Zip;
using ICSharpCode.SharpZipLib.Core;

namespace bakup_mssql
{
    class backup_mssql : report
    {
        SqlConnection connection;
        SqlCommand command;
        String connectionString;
        String src = "", dst = "";
        
        private FastZip fzip;
        private string base_db;
        private int j;

        public static string info_base;

        public void copy_konst(string base_db, int j)
        {
            this.base_db = base_db;
            this.j = j;
            src = conf[3].ToString() + db[j].ToString();
            dst = conf[4].ToString() + db[j].ToString();
            dir(src); dir(dst);
            connect();
        }

        private void dir(string path)
        {
            if (!Directory.Exists(path))
            {
                Directory.CreateDirectory(path);
            }

        }

      

        private void connect()
        {
            connectionString = "server=" + conf[0].ToString() + ";uid=" + conf[1].ToString() + ";pwd=" + conf[2].ToString();
            connection = new SqlConnection(connectionString);
            try
            {
                connection.Open();


            }
            catch (SqlException e)
            {
                smtp(e.Message.ToString() + "\n");
                Environment.Exit(0);
            }

           
            backup();
        }

        private void backup()
        {
            command = connection.CreateCommand();
            command.Connection = connection;
            command.CommandText = "BACKUP DATABASE [" + db[j].ToString() + "] TO  DISK = N'" + src + @"\" + base_db + ".bak" + "' WITH NOFORMAT, INIT, SKIP, NOREWIND, NOUNLOAD, STATS = 10";
            command.CommandTimeout = 0;

            try
            {
                Console.WriteLine("BASE_NAME - " + db[j].ToString());
                Console.WriteLine("PATH - " + src + @"\" + base_db + ".bak");
                Console.WriteLine("Script - " + command.CommandText + "\n\n");
                info_base = info_base + "BASE_NAME - " + db[j].ToString() + "\n" + "PATH - " + src + @"\" + base_db + ".bak" + "\n" + "Script - " + command.CommandText + "\n\n\n";
                command.ExecuteNonQuery();
                compress();
            }
            catch (SqlException e)
            {
                smtp(e.Message.ToString() + "\n" + db[j].ToString() + " = base unowkn or nedostupna");
            }

            connection.Close();


        }
        private void compress()
        {
            fzip = new FastZip();
            fzip.CreateZip(conf[3].ToString() + base_db + ".zip", src, true, null);

            file_oper();

        }

        private void file_oper()
        {
            try
            {
                File.Copy(conf[3].ToString() + base_db + ".zip", dst + @"\" + base_db + ".zip", true);
                Directory.Delete(src, true);
                File.Delete(conf[3].ToString() + base_db + ".zip");
            }
            catch (Exception e)
            {
                smtp(e.Message);
            }

        }

    }

}
