﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Net.Mail;

namespace bakup_mssql
{
    class report : raznoe
    {
        private DirectoryInfo dir;
        private FileInfo[] file;
        private string reports = "";

        private void getfiles(string path)
        {
            dir = new DirectoryInfo(path);
            reports = reports + path + "\n";
            try
            {
                file = dir.GetFiles();
                foreach (FileInfo files in file)
                {

                    reports = reports + "         " + files.LastAccessTime + " " + (files.Length/1024)/1024+"Mb" + " " + files.Name + "\n";
                    
                }
                reports = reports + "\n";

            }
            catch (Exception e)
            {
                smtp(e.Message.ToString() + "\n");

            }
        }

        public void file_report()
        {
            string[] subdirectoryEntries;
            try
            {
                subdirectoryEntries = Directory.GetDirectories(conf[4].ToString());
                foreach (string subdirectory in subdirectoryEntries)
                    getfiles(subdirectory);

            }
            catch (Exception e)
            {
                smtp(e.Message.ToString() + "\n");

            }

            smtp(backup_mssql.info_base);
            smtp(reports);

        }

        public void smtp(string reports)
        {
            string[] eml;
            int i;
            eml = conf[9].ToString().Split(' ');
            for (i = 0; i < eml.Length; i++)
            {

                string server = conf[5].ToString();
                string msg_from = conf[8].ToString();
                string smtp_login = conf[6].ToString();
                string smtp_pass = conf[7].ToString();
                string msg_to = eml[i];
                string msg_subj = "backup_mssql_report";


                MailMessage message = new MailMessage(msg_from, msg_to, msg_subj, reports);
                SmtpClient client = new SmtpClient(server, 25);
                client.Credentials = new System.Net.NetworkCredential(smtp_login, smtp_pass);
                try
                {
                    client.Send(message);
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message);
                    Console.ReadLine();
                }

            }
        }

    }
}
